## libayatana-appindicator 0.5.93

=== bindings/CMakeLists.txt ===
if (ENABLE_BINDINGS_VALA AND FLAVOUR_GTK3)
    add_subdirectory(vala)
endif()
if (ENABLE_BINDINGS_MONO)
    add_subdirectory(mono)
endif()
