=== debian/changelog ===
libayatana-appindicator (0.5.93-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 01:40:12 +0000

libayatana-appindicator (0.5.93-1build2) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 11 Mar 2024 22:57:38 +0000

libayatana-appindicator (0.5.93-1build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 05:18:59 +0000

libayatana-appindicator (0.5.93-1) unstable; urgency=medium

  * New upstream release.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 29 Oct 2023 10:09:55 +0100

libayatana-appindicator (0.5.92-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Drop CIL packages (Closes: #1043280).
  * Drop GTK2 remains.

 -- Bastian Germann <bage@barriere.debian.org>  Fri, 11 Aug 2023 09:42:50 +0000

libayatana-appindicator (0.5.92-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Drop GTK2 packages (Closes: #967567).

 -- Bastian Germann <bage@debian.org>  Wed, 28 Jun 2023 23:28:24 +0200
