=== debian/changelog ===
libayatana-appindicator (0.5.93+really-3) unstable; urgency=medium

  * debian/control:
    + Revert "debian/control: Switch from gobject-introspection to gobject-
      introspection-bin. Thanks, lintian." (Closes: #1094617).
    + Fix typo in Vcs-Browser: field. (Closes: #1094618).

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 29 Jan 2025 13:08:07 +0100

libayatana-appindicator (0.5.93+really-2) unstable; urgency=medium

  * debian/patches:
    + Add 1001_fix-tests-on-riscv64.patch. Increase g_usleep delay to meet
      slowliness of riscv64 hardware in Debian's buildd setup. (Closes:
      #1086191).

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 11 Dec 2024 22:51:11 +0100

libayatana-appindicator (0.5.93+really-1) unstable; urgency=medium

  * Upstream re-release of 0.5.93 tarball. (Closes: #1070246).
    - The previous 0.5.93 orig tarball was actually a 0.5.90 release. Thanks
      to Carlos Alberto Lopez Perez for spotting this.
  * debian/copyright:
    + Update copyright attributions.
  * debian/libayatana-appindicator3-1.symbols:
    + Update symbols. Private symbol removed.
  * debian/control:
    + Switch from gobject-introspection to gobject-introspection-bin. Thanks,
      lintian.
    + Bump Standards-Version to 4.7.0. No changes needed.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 02 May 2024 21:27:44 +0200
