=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: libayatana-appindicator
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Ayatana Packagers <pkg-ayatana-devel@lists.alioth.debian.org>
+Maintainer: Ayatana Packagers <pkg-ayatana-devel@lists.alioth.debian.org>
 Uploaders:
  Mike Gabriel <sunweaver@debian.org>,
 Build-Depends: cmake,
@@ -24,11 +23,11 @@
                libdbusmenu-glib-dev,
                libdbusmenu-gtk3-dev,
                libgirepository1.0-dev,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://github.com/AyatanaIndicators/libayatana-appindicator
 Vcs-Git: https://salsa.debian.org/debian-ayatana-team/libayatana-appindicator.git
-Vcs-Browser: https://salsa.debian.org/debian-edu-ayatana-team/libayatana-appindicator
+Vcs-Browser: https://salsa.debian.org/debian-ayatana-team/libayatana-appindicator
 
 Package: libayatana-appindicator-doc
 Section: doc
